Package io.vertx.core.spi.transport

## Interface Transport

-     public interface Transport

  The transport used by a `Vertx` instance.

  Author:
    Julien Viet

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static int` | `ACCEPTOR_EVENT_LOOP_GROUP` |
    `static int` | `IO_EVENT_LOOP_GROUP` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `ChannelFactory<? extends Channel>` | `channelFactory​(boolean domainSocket)` |
    `default void` | `configure​(DatagramChannel channel, DatagramSocketOptions options)` |
    `default void` | `configure​(ClientOptionsBase options, int connectTimeout, boolean domainSocket, Bootstrap bootstrap)` |
    `default void` | `configure​(NetServerOptions options, boolean domainSocket, ServerBootstrap bootstrap)` |
    `default SocketAddress` | `convert​(SocketAddress address)` |
    `default SocketAddress` | `convert​(SocketAddress address)` |
    `DatagramChannel` | `datagramChannel()` |
    `DatagramChannel` | `datagramChannel​(InternetProtocolFamily family)` |
    `default EventLoopGroup` | `eventLoopGroup​(int type, int nThreads, ThreadFactory threadFactory, int ioRatio)` |
    `IoHandlerFactory` | `ioHandlerFactory()` |
    `default boolean` | `isAvailable()` |
    `ChannelFactory<? extends ServerChannel>` | `serverChannelFactory​(boolean domainSocket)` |
    `default boolean` | `supportFileRegion()` |
    `default boolean` | `supportsDomainSockets()` |
    `default Throwable` | `unavailabilityCause()` |

- - ### Field Detail

    - #### ACCEPTOR_EVENT_LOOP_GROUP

          static final int ACCEPTOR_EVENT_LOOP_GROUP

      See Also:
        Constant Field Values

    - #### IO_EVENT_LOOP_GROUP

          static final int IO_EVENT_LOOP_GROUP

      See Also:
        Constant Field Values

  - ### Method Detail

    - #### supportsDomainSockets

          default boolean supportsDomainSockets()

    - #### supportFileRegion

          default boolean supportFileRegion()

    - #### isAvailable

          default boolean isAvailable()

      Returns:
        true when the transport is available.

    - #### unavailabilityCause

          default Throwable unavailabilityCause()

      Returns:
        the error that cause the unavailability when `isAvailable()` returns `null`.

    - #### convert

          default SocketAddress convert​(SocketAddress address)

    - #### convert

          default SocketAddress convert​(SocketAddress address)

    - #### ioHandlerFactory

          IoHandlerFactory ioHandlerFactory()

    - #### eventLoopGroup

          default EventLoopGroup eventLoopGroup​(int type,
                                                int nThreads,
                                                ThreadFactory threadFactory,
                                                int ioRatio)

      Parameters:
        `type` - one of `ACCEPTOR_EVENT_LOOP_GROUP` or `IO_EVENT_LOOP_GROUP`.
        `nThreads` - the number of threads that will be used by this instance.
        `threadFactory` - the ThreadFactory to use.
        `ioRatio` - the IO ratio
      Returns:
        a new event loop group

    - #### datagramChannel

          DatagramChannel datagramChannel()

      Returns:
        a new datagram channel

    - #### datagramChannel

          DatagramChannel datagramChannel​(InternetProtocolFamily family)

      Returns:
        a new datagram channel

    - #### channelFactory

          ChannelFactory<? extends Channel> channelFactory​(boolean domainSocket)

      Parameters:
        `domainSocket` - whether to create a unix domain channel or a socket channel
      Returns:
        the type for channel

    - #### serverChannelFactory

          ChannelFactory<? extends ServerChannel> serverChannelFactory​(boolean domainSocket)

      Parameters:
        `domainSocket` - whether to create a server unix domain channel or a regular server socket channel
      Returns:
        the type for server channel

    - #### configure

          default void configure​(DatagramChannel channel,
                                 DatagramSocketOptions options)

    - #### configure

          default void configure​(ClientOptionsBase options,
                                 int connectTimeout,
                                 boolean domainSocket,
                                 Bootstrap bootstrap)

    - #### configure

          default void configure​(NetServerOptions options,
                                 boolean domainSocket,
                                 ServerBootstrap bootstrap)